blob: 3bee6dc725951d56e5187cdde91fe6fa10ae637c [file] [log] [blame]
Peter Stuge09377b72011-08-21 06:24:55 +02001#!/bin/sh
Stefan Reinauer074d9132009-09-26 16:43:17 +00002#
Stefan Reinauer5f1ad892010-05-17 11:02:25 +00003# Copyright (C) 2008-2010 by coresystems GmbH
Stefan Reinauer074d9132009-09-26 16:43:17 +00004# written by Patrick Georgi <patrick.georgi@coresystems.de> and
5# Stefan Reinauer <stefan.reinauer@coresystems.de>
Stefan Reinauer14e22772010-04-27 06:56:47 +00006#
Marc Jones2aac3f62011-08-08 16:07:50 -06007# Copyright (C) 2011 by Sage Electronic Engineering
8#
Stefan Reinauer074d9132009-09-26 16:43:17 +00009# This program is free software; you can redistribute it and/or modify
10# it under the terms of the GNU General Public License as published by
11# the Free Software Foundation; version 2 of the License.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the GNU General Public License
19# along with this program; if not, write to the Free Software
Patrick Georgib890a122015-03-26 15:17:45 +010020# Foundation, Inc.
Stefan Reinauer074d9132009-09-26 16:43:17 +000021#
22
Stefan Reinauerd7649122015-06-09 11:44:25 -070023cd $(dirname $0)
Patrick Georgi8135dba2015-03-17 21:05:20 +010024
Stefan Reinauerbed95b22015-06-09 13:41:40 -070025CROSSGCC_DATE="June 9th, 2015"
26CROSSGCC_VERSION="1.30"
Stefan Reinauer074d9132009-09-26 16:43:17 +000027
28# default settings
Stefan Reinauer85b07d62015-06-09 14:45:14 -070029PACKAGE=GCC
Stefan Reinauerd7649122015-06-09 11:44:25 -070030TARGETDIR=$(pwd)/xgcc
Stefan Reinauer074d9132009-09-26 16:43:17 +000031TARGETARCH=i386-elf
32DESTDIR=
Stefan Reinauer85b07d62015-06-09 14:45:14 -070033SAVETEMPS=0
34SKIPPYTHON=1
Stefan Reinauer074d9132009-09-26 16:43:17 +000035
Stefan Reinauer699ac272015-06-05 12:43:28 -070036# GCC toolchain version numbers
Patrick Georgi53c388f2015-03-07 09:55:18 +010037GMP_VERSION=6.0.0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070038MPFR_VERSION=3.1.2
Paul Menzele6619422015-02-23 10:33:59 +010039MPC_VERSION=1.0.3
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000040LIBELF_VERSION=0.8.13
Patrick Georgi53c388f2015-03-07 09:55:18 +010041GCC_VERSION=4.9.2
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070042GCC_AUTOCONF_VERSION=2.69
Patrick Georgi53c388f2015-03-07 09:55:18 +010043BINUTILS_VERSION=2.25
Stefan Reinauerbed95b22015-06-09 13:41:40 -070044GDB_VERSION=7.9.1
Patrick Georgi53c388f2015-03-07 09:55:18 +010045IASL_VERSION=20150204
46PYTHON_VERSION=3.4.3
Idwer Vollering296a0152012-10-26 01:48:04 +020047EXPAT_VERSION=2.1.0
Stefan Reinauer14ce2132015-06-05 13:01:13 -070048# CLANG version number
49CLANG_VERSION=3.6.1
Stefan Reinauer074d9132009-09-26 16:43:17 +000050
Stefan Reinauer699ac272015-06-05 12:43:28 -070051# GCC toolchain archive locations
Patrick Georgi53c388f2015-03-07 09:55:18 +010052GMP_ARCHIVE="http://ftpmirror.gnu.org/gmp/gmp-${GMP_VERSION}a.tar.bz2"
Patrick Georgi6e61ad32012-05-12 23:19:30 +020053MPFR_ARCHIVE="http://ftpmirror.gnu.org/mpfr/mpfr-${MPFR_VERSION}.tar.bz2"
Idwer Vollering7962fc72012-10-25 02:14:09 +020054MPC_ARCHIVE="http://ftpmirror.gnu.org/mpc/mpc-${MPC_VERSION}.tar.gz"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000055LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
Idwer Vollering1cfee0b2012-10-25 02:03:53 +020056GCC_ARCHIVE="http://ftpmirror.gnu.org/gcc/gcc-${GCC_VERSION}/gcc-${GCC_VERSION}.tar.bz2"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070057BINUTILS_ARCHIVE="http://ftpmirror.gnu.org/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
Patrick Georgi53c388f2015-03-07 09:55:18 +010058GDB_ARCHIVE="http://ftpmirror.gnu.org/gdb/gdb-${GDB_VERSION}.tar.xz"
59IASL_ARCHIVE="https://acpica.org/sites/acpica/files/acpica-unix-${IASL_VERSION}.tar.gz"
60PYTHON_ARCHIVE="http://www.python.org/ftp/python/${PYTHON_VERSION}/Python-${PYTHON_VERSION}.tar.xz"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010061EXPAT_ARCHIVE="http://downloads.sourceforge.net/sourceforge/expat/expat-${EXPAT_VERSION}.tar.gz"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070062# CLANG toolchain archive locations
63LLVM_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/llvm-${CLANG_VERSION}.src.tar.xz"
64CFE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/cfe-${CLANG_VERSION}.src.tar.xz"
65CRT_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/compiler-rt-${CLANG_VERSION}.src.tar.xz"
66CTE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/clang-tools-extra-${CLANG_VERSION}.src.tar.xz"
Stefan Reinauer074d9132009-09-26 16:43:17 +000067
Stefan Reinauer699ac272015-06-05 12:43:28 -070068# GCC toolchain directories
Stefan Reinauer074d9132009-09-26 16:43:17 +000069GMP_DIR="gmp-${GMP_VERSION}"
70MPFR_DIR="mpfr-${MPFR_VERSION}"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000071MPC_DIR="mpc-${MPC_VERSION}"
72LIBELF_DIR="libelf-${LIBELF_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000073GCC_DIR="gcc-${GCC_VERSION}"
74BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
75GDB_DIR="gdb-${GDB_VERSION}"
Marc Jones2aac3f62011-08-08 16:07:50 -060076IASL_DIR="acpica-unix-${IASL_VERSION}"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010077PYTHON_DIR="Python-${PYTHON_VERSION}"
78EXPAT_DIR="expat-${EXPAT_VERSION}"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070079# CLANG toolchain directories
80LLVM_DIR="llvm-${CLANG_VERSION}.src"
81CFE_DIR="cfe-${CLANG_VERSION}.src"
82CRT_DIR="compiler-rt-${CLANG_VERSION}.src"
83CTE_DIR="clang-tools-extra-${CLANG_VERSION}.src"
Stefan Reinauer074d9132009-09-26 16:43:17 +000084
Patrick Georgi6321f522015-02-27 23:36:26 +010085unset MAKELEVEL MAKEFLAGS
86
Patrick Georgi1861ff72011-10-31 12:15:55 +010087red='\033[0;31m'
88RED='\033[1;31m'
89green='\033[0;32m'
90GREEN='\033[1;32m'
91blue='\033[0;34m'
92BLUE='\033[1;34m'
93cyan='\033[0;36m'
94CYAN='\033[1;36m'
95NC='\033[0m' # No Color
Stefan Reinauer074d9132009-09-26 16:43:17 +000096
Stefan Reinauerd7649122015-06-09 11:44:25 -070097UNAME=$(uname)
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070098
Patrick Georgi198d23c2012-12-08 08:02:44 +010099normalize_dirs()
100{
101 mkdir -p $DESTDIR$TARGETDIR/lib
102 test -d $DESTDIR$TARGETDIR/lib32 && mv $DESTDIR$TARGETDIR/lib32/* $DESTDIR$TARGETDIR/lib
103 test -d $DESTDIR$TARGETDIR/lib64 && mv $DESTDIR$TARGETDIR/lib64/* $DESTDIR$TARGETDIR/lib
104 rmdir -p $DESTDIR$TARGETDIR/lib32 $DESTDIR$TARGETDIR/lib64
105
106 perl -pi -e "s,/lib32,/lib," $DESTDIR$TARGETDIR/lib/*.la
107 perl -pi -e "s,/lib64,/lib," $DESTDIR$TARGETDIR/lib/*.la
108}
109
Patrick Georgib7062882015-02-24 10:52:14 +0100110searchtool()
Stefan Reinauer074d9132009-09-26 16:43:17 +0000111{
112 # $1 short name
Patrick Georgib7062882015-02-24 10:52:14 +0100113 # $2 search string
114 # $3 soft fail if set
115 # result: file name of that tool on stdout
116 # or no output if nothing suitable was found
117 search=GNU
118 if [ -n "$2" ]; then
119 search="$2"
120 fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000121 for i in "$1" "g$1" "gnu$1"; do
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700122 if [ -x "$(which $i 2>/dev/null)" ]; then
123 if [ "$(cat /dev/null | $i --version 2>&1 | grep -c "$search")" \
124 -gt 0 ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000125 echo $i
126 return
127 fi
128 fi
129 done
Andrew Wub67e9a12014-04-28 18:13:44 +0800130 # A workaround for OSX 10.9 and some BSDs, whose nongnu
131 # patch and tar also work.
Patrick Georgi7cb26b42015-04-28 21:29:22 +0200132 if [ $UNAME = "Darwin" -o $UNAME = "FreeBSD" -o $UNAME = "NetBSD" -o $UNAME = "OpenBSD" ]; then
Patrick Georgib7062882015-02-24 10:52:14 +0100133 if [ "$1" = "patch" -o "$1" = "tar" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700134 if [ -x "$(which $1 2>/dev/null)" ]; then
Zheng Bao36156ff2012-09-28 16:18:58 +0800135 echo $1
136 return
137 fi
138 fi
139 fi
Stefan Reinauerd7649122015-06-09 11:44:25 -0700140 if [ "$(echo $1 | cut -b -3)" = "sha" ]; then
zbao939dc842015-04-30 04:44:07 +0800141 if [ $UNAME = "FreeBSD" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700142 if [ -x "$(which sha1 2>/dev/null)" ]; then
zbao939dc842015-04-30 04:44:07 +0800143 echo sha1
144 return
145 fi
146 fi
147 if [ $UNAME = "NetBSD" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700148 if [ -x "$(which cksum 2>/dev/null)" ]; then
Stefan Reinauerd7649122015-06-09 11:44:25 -0700149 echo cksum -a $(echo $1 | sed -e 's,sum,,')
zbao939dc842015-04-30 04:44:07 +0800150 return
151 fi
152 fi
153 if [ $UNAME = "Darwin" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700154 if [ -x "$(which openssl 2>/dev/null)" ]; then
Stefan Reinauerd7649122015-06-09 11:44:25 -0700155 echo openssl $(echo $1 | sed -e 's,sum,,')
zbao939dc842015-04-30 04:44:07 +0800156 return
157 fi
158 fi
159 fi
Patrick Georgiae5ab602015-04-29 23:30:15 +0200160 printf "${RED}ERROR:${red} Missing tool: Please install $1 (eg using your OS packaging system)${NC}\n" >&2
Patrick Georgib7062882015-02-24 10:52:14 +0100161 [ -z "$3" ] && exit 1
162 false
Stefan Reinauer074d9132009-09-26 16:43:17 +0000163}
164
Stefan Reinauerd7649122015-06-09 11:44:25 -0700165TAR=$(searchtool tar) || exit $?
166PATCH=$(searchtool patch) || exit $?
167MAKE=$(searchtool make) || exit $?
168CMAKE=$(searchtool cmake "cmake") || exit $?
169SHA1SUM=$(searchtool sha1sum)
170SHA512SUM=$(searchtool sha512sum)
Stefan Reinauer699ac272015-06-05 12:43:28 -0700171CHECKSUM=$SHA1SUM
Stefan Reinauer074d9132009-09-26 16:43:17 +0000172
Patrick Georgib7062882015-02-24 10:52:14 +0100173searchtool m4 > /dev/null
174searchtool bison > /dev/null
175searchtool flex flex > /dev/null
176searchtool g++ "Free Software Foundation" nofail > /dev/null || \
Patrick Georgi915c4fc2015-03-09 13:58:23 +0100177searchtool clang "clang version" > /dev/null
178searchtool wget > /dev/null
179searchtool bzip2 "bzip2," > /dev/null
Patrick Georgi5fb2b5c2012-05-12 23:25:23 +0200180
Stefan Reinauer88935482015-06-05 09:51:10 -0700181download() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700182 package=$1
183 archive="$(eval echo \$$package"_ARCHIVE")"
Stefan Reinauer699ac272015-06-05 12:43:28 -0700184
Stefan Reinauerd7649122015-06-09 11:44:25 -0700185 FILE=$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700186 printf " * $FILE "
187
188 test -f tarballs/$FILE && \
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700189 ( test -z "$CHECKSUM" || \
190 test "$(cat sum/$FILE.cksum 2>/dev/null | \
191 sed -e 's,.*\([0-9a-f]\{40\}\).*,\1,')" = \
192 "$($CHECKSUM tarballs/$FILE 2>/dev/null | \
193 sed -e 's,.*\([0-9a-f]\{40\}\).*,\1,')" ) && \
Stefan Reinauer88935482015-06-05 09:51:10 -0700194 printf "(cached)" || (
195 printf "(downloading)"
196 rm -f tarballs/$FILE
197 cd tarballs
Stefan Reinauer699ac272015-06-05 12:43:28 -0700198 wget --no-check-certificate -q $archive
Stefan Reinauer88935482015-06-05 09:51:10 -0700199 cd ..
200 test ! -f sum/$FILE.cksum && test -f tarballs/$FILE && \
201 (test -z "$CHECKSUM" || $CHECKSUM tarballs/$FILE > sum/$FILE.cksum ) && \
202 printf "(checksum created. ${RED}Note. Please upload sum/$FILE.cksum if the corresponding archive is upgraded.${NC})"
203 )
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700204 if [ ! -f tarballs/$FILE ]; then
Stefan Reinauer88935482015-06-05 09:51:10 -0700205 printf "\n${RED}Failed to download $FILE.${NC}\n"
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700206 exit 1
207 fi
Stefan Reinauer88935482015-06-05 09:51:10 -0700208 printf "\n"
209}
210
211unpack_and_patch() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700212 package=$1
213 archive="$(eval echo \$$package"_ARCHIVE")"
214 dir="$(eval echo \$$package"_DIR")"
Stefan Reinauer88935482015-06-05 09:51:10 -0700215 test -d ${dir} && test -f ${dir}/.unpack_success || (
Stefan Reinauerd7649122015-06-09 11:44:25 -0700216 printf " * $(basename $archive)\n"
Stefan Reinauer88935482015-06-05 09:51:10 -0700217 FLAGS=zxf
Stefan Reinauerd7649122015-06-09 11:44:25 -0700218 suffix=$(echo $archive | sed 's,.*\.,,')
Stefan Reinauer88935482015-06-05 09:51:10 -0700219 test "$suffix" = "gz" && FLAGS=zxf
220 test "$suffix" = "bz2" && FLAGS=jxf
221 test "$suffix" = "xz" && FLAGS="--xz -xf"
222 test "$suffix" = "lzma" && FLAGS="--lzma -xf"
Stefan Reinauerd7649122015-06-09 11:44:25 -0700223 $TAR $FLAGS tarballs/$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700224 for patch in patches/${dir}_*.patch; do
225 test -r $patch || continue
Stefan Reinauerd7649122015-06-09 11:44:25 -0700226 printf " o $(basename $patch)\n"
Stefan Reinauer916b8452015-06-09 11:54:49 -0700227 $PATCH -s -N -p0 < $(echo $patch) || {
Stefan Reinauer88935482015-06-05 09:51:10 -0700228 printf "\n${RED}Failed $patch.${NC}\n"
Stefan Reinauer916b8452015-06-09 11:54:49 -0700229 exit 1
230 }
Stefan Reinauer88935482015-06-05 09:51:10 -0700231 done
232 touch ${dir}/.unpack_success
233 )
234}
235
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700236fn_exists()
237{
238 type $1 2>/dev/null | grep -q 'is a function'
Patrick Georgi74c06422015-03-25 18:40:13 +0100239}
240
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700241build() {
242 package=$1
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700243
244 fn_exists build_$package || return
245
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700246 version="$(eval echo \$$package"_VERSION")"
247 BUILDDIR=build-${TARGETARCH}-$package
248
249 mkdir -p ${BUILDDIR}
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700250
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700251 [[ "$PACKAGES" == *$package* ]] && \
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700252 if [ -f ${BUILDDIR}/.success ]; then
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700253 printf "Skipping $package as it is already built\n"
254 else
255 printf "Building $package $version ... "
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700256 DIR=$PWD
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700257 cd ${BUILDDIR}
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700258 rm -f .failed
259 build_${package} > build.log 2>&1
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700260 cd $DIR/${BUILDDIR}
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700261 if [ ! -f .failed ]; then touch .success; fi
262 cd ..
263
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700264 if [ -r "${BUILDDIR}/.failed" ]; then
265 printf "${RED}failed${NC}. Check ${BUILDDIR}/build.log.\n"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700266 exit 1
267 fi
268 printf "${green}ok${NC}\n"
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700269 fi
270}
271
Stefan Reinauer074d9132009-09-26 16:43:17 +0000272cleanup()
273{
274 printf "Cleaning up temporary files... "
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700275 for package in $PACKAGES; do
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700276 rm -rf build-${TARGETARCH}-$package $(eval echo \$$package"_DIR")
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700277 done
Stefan Reinauer074d9132009-09-26 16:43:17 +0000278 printf "${green}ok${NC}\n"
279}
280
281myhelp()
282{
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700283 printf "Usage: $0 [-V] [-c] [-p <platform>] [-d <target directory>] [-D <dest dir>] [-C] [-G] [-S]\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000284 printf " $0 [-V|--version]\n"
285 printf " $0 [-h|--help]\n\n"
286
287 printf "Options:\n"
288 printf " [-V|--version] print version number and exit\n"
289 printf " [-h|--help] print this help and exit\n"
290 printf " [-c|--clean] remove temporary files before build\n"
291 printf " [-t|--savetemps] don't remove temporary files after build\n"
Patrick Georgic1a75b12011-11-04 21:37:14 +0100292 printf " [-y|--ccache] Use ccache when building cross compiler\n"
Patrick Georgi73166c72010-04-14 20:42:42 +0000293 printf " [-j|--jobs <num>] run <num> jobs in parallel in make\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000294 printf " [-d|--directory <target dir>] target directory to install cross compiler to\n"
295 printf " (defaults to $TARGETDIR)\n\n"
296 printf " [-D|--destdir <dest dir>] destination directory to install cross compiler to\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100297 printf " (for RPM builds, default unset)\n"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700298 printf " [-P|--package <package>] Build a specific package: GCC, CLANG, IASL, GDB\n"
299 printf " (defaults to $PACKAGE)\n"
300 printf "GCC specific options:\n"
301 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
302 printf " (defaults to $TARGETARCH)\n"
303 printf "GDB specific options:\n"
304 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
305 printf " (defaults to $TARGETARCH)\n"
306 printf " [-S|--scripting] build scripting support for GDB\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000307}
308
309myversion()
310{
311 # version tag is always printed, so just print the license here
312
313 cat << EOF
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000314Copyright (C) 2008-2010 by coresystems GmbH
Marc Jones2aac3f62011-08-08 16:07:50 -0600315Copyright (C) 2011 by Sage Electronic Engineering
Stefan Reinauer074d9132009-09-26 16:43:17 +0000316
317This program is free software; you can redistribute it and/or modify
318it under the terms of the GNU General Public License as published by
319the Free Software Foundation; version 2 of the License.
320
321This program is distributed in the hope that it will be useful,
322but WITHOUT ANY WARRANTY; without even the implied warranty of
323MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
324GNU General Public License for more details.
325
326EOF
327}
328
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700329build_GMP() {
330 CC="$CC" CFLAGS="-Os" ../${GMP_DIR}/configure --disable-shared --enable-fat --prefix=$TARGETDIR $OPTIONS \
331 || touch .failed
332 $MAKE $JOBS || touch .failed
333 $MAKE install DESTDIR=$DESTDIR || touch .failed
334
335 normalize_dirs
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700336
337 # Now set CFLAGS to match GMP CFLAGS but strip out -pedantic
338 # as GCC 4.6.x fails if it's there.
339 export HOSTCFLAGS=$(grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2 |\
340 sed s,-pedantic,,)
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700341}
342
343build_MPFR() {
344 test $UNAME = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
345 CC="$CC" ../${MPFR_DIR}/configure --disable-shared --prefix=$TARGETDIR \
346 --infodir=$TARGETDIR/info \
347 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
348 touch .failed
349 $MAKE $JOBS || touch .failed
350 $MAKE install DESTDIR=$DESTDIR || touch .failed
351
352 normalize_dirs
353
354 # work around build problem of libgmp.la
355 if [ "$DESTDIR" != "" ]; then
356 perl -pi -e "s,$DESTDIR,," $DESTDIR$TARGETDIR/libgmp.la
357 fi
358}
359
360build_MPC() {
361 CC="$CC" ../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \
362 --infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \
363 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
364 touch .failed
365 $MAKE $JOBS || touch .failed
366 $MAKE install DESTDIR=$DESTDIR || touch .failed
367
368 normalize_dirs
369}
370
371build_LIBELF() {
372 CC="$CC" CFLAGS="$HOSTCFLAGS" libelf_cv_elf_h_works=no \
373 ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \
374 --infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed
375 $MAKE $JOBS || touch .failed
376 $MAKE install prefix=$DESTDIR$TARGETDIR || touch .failed
377
378 normalize_dirs
379}
380
381build_BINUTILS() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700382 # Now build binutils
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700383 CC="$CC" ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR \
384 --target=${TARGETARCH} --disable-werror --disable-nls \
Stefan Reinauer2f97ebc2015-06-09 12:24:54 -0700385 --enable-lto --enable-gold --enable-plugins CFLAGS="$HOSTCFLAGS" || touch .failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700386 $MAKE $JOBS || touch .failed
387 $MAKE install DESTDIR=$DESTDIR || touch .failed
388}
389
390
391build_GCC() {
Stefan Reinauerd0f83722015-06-09 11:52:28 -0700392 # GCC does not honor HOSTCFLAGS at all. CFLAGS are used for
393 # both target and host object files.
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700394 # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
395 # but it does not seem to work properly. At least the host library
396 # libiberty is not compiled with CFLAGS_FOR_BUILD.
397 CC="$CC" CFLAGS_FOR_TARGET="-O2" CFLAGS="$HOSTCFLAGS" \
398 CFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
399 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
400 --target=${TARGETARCH} --disable-werror --disable-shared \
Stefan Reinauer2f97ebc2015-06-09 12:24:54 -0700401 --enable-lto --enable-plugins --enable-gold --enable-ld=default \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700402 --disable-libssp --disable-bootstrap --disable-nls \
403 --disable-libquadmath --without-headers \
Stefan Reinauer2f97ebc2015-06-09 12:24:54 -0700404 ${GCC_OPTIONS} --enable-languages="c" \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700405 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
406 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
407 --with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \
408 || touch .failed
409 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-gcc || touch .failed
410 $MAKE install-gcc DESTDIR=$DESTDIR || touch .failed
411
Stefan Reinauerd7649122015-06-09 11:44:25 -0700412 if [ "$(echo $TARGETARCH | grep -c -- -mingw32)" -eq 0 ]; then
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700413 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-target-libgcc || touch .failed
414 $MAKE install-target-libgcc DESTDIR=$DESTDIR || touch .failed
415 fi
416}
417
418build_EXPAT() {
419 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${EXPAT_DIR}/configure --disable-shared \
420 --prefix=$TARGETDIR --target=${TARGETARCH} || touch .failed
421 $MAKE || touch .failed
422 $MAKE install DESTDIR=$DESTDIR || touch .failed
423
424 normalize_dirs
425}
426
427build_PYTHON() {
428 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${PYTHON_DIR}/configure --prefix=$TARGETDIR \
429 --target=${TARGETARCH} || touch .failed
430 $MAKE $JOBS || touch .failed
431 $MAKE install DESTDIR=$DESTDIR || touch .failed
432
433 normalize_dirs
434}
435
436build_GDB() {
437 export PYTHONHOME=$DESTDIR$TARGETDIR
438 if [ $(uname) != "FreeBSD" -a $(uname) != "NetBSD" ]; then
439 LIBDL="-ldl"
440 fi
441 LDFLAGS="-Wl,-rpath,\$\$ORIGIN/../lib/ -L$DESTDIR$TARGETDIR/lib \
442 -lpthread $LIBDL -lutil" \
443 CC="$CC" CFLAGS="$HOSTCFLAGS -I$DESTDIR$TARGETDIR/include" \
Stefan Reinauer7b40e422015-06-09 11:56:32 -0700444 ../${GDB_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700445 --target=${TARGETARCH} --disable-werror --disable-nls
446 $MAKE $JOBS || touch .failed
447 $MAKE install DESTDIR=$DESTDIR || touch .failed
448}
449
450build_IASL() {
451 RDIR=$PWD
452 cd ../$IASL_DIR/generate/unix
453 CFLAGS="$HOSTCFLAGS"
454 HOST="_LINUX"
455 test $UNAME = "Darwin" && HOST="_APPLE"
456 test $UNAME = "FreeBSD" && HOST="_FreeBSD"
457 test $UNAME = "Cygwin" && HOST="_CYGWIN"
458 HOST="$HOST" OPT_CFLAGS="-O -D_FORTIFY_SOURCE=2" CFLAGS="$CFLAGS" $MAKE CC="$CC" iasl || touch $RDIR/.failed
459 rm -f $DESTDIR$TARGETDIR/bin/iasl || touch $RDIR/.failed
460 cp bin/iasl $DESTDIR$TARGETDIR/bin || touch $RDIR/.failed
461}
462
463build_LLVM() {
464 cd ..
465 ln -sf $PWD/$CFE_DIR $LLVM_DIR/tools/clang
466 ln -sf $PWD/$CTE_DIR $LLVM_DIR/tools/clang/tools/extra
467 ln -sf $PWD/$CRT_DIR $LLVM_DIR/projects/compiler-rt
468 cd -
469
470 $CMAKE -G "Unix Makefiles" -DCMAKE_INSTALL_PREFIX=$DESTDIR$TARGETDIR \
471 -DCMAKE_BUILD_TYPE=Release ../$LLVM_DIR || touch .failed
472 $MAKE $JOBS || touch .failed
473 $MAKE install || touch .failed
474
475 cp -a ../$CFE_DIR/tools/scan-build/* $DESTDIR$TARGETDIR/bin
476 cp -a ../$CFE_DIR/tools/scan-view/* $DESTDIR$TARGETDIR/bin
477}
478
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700479printf "${blue}Welcome to the ${red}coreboot${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000480
Patrick Georgi6bba29f2010-01-29 17:40:52 +0000481# Look if we have getopt. If not, build it.
482export PATH=$PATH:.
483getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
484
Stefan Reinauer074d9132009-09-26 16:43:17 +0000485# parse parameters.. try to find out whether we're running GNU getopt
Stefan Reinauerd7649122015-06-09 11:44:25 -0700486getoptbrand="$(getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,')"
Peter Stuge09377b72011-08-21 06:24:55 +0200487if [ "${getoptbrand}" = "getopt" ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000488 # Detected GNU getopt that supports long options.
Stefan Reinauerd7649122015-06-09 11:44:25 -0700489 args=$(getopt -l version,help,clean,directory:,platform:,jobs:,destdir:,savetemps,skip-gdb,ccache,clang Vhcd:p:j:D:tGyC -- "$@")
Stefan Reinauer074d9132009-09-26 16:43:17 +0000490 eval set "$args"
491else
492 # Detected non-GNU getopt
Stefan Reinauerd7649122015-06-09 11:44:25 -0700493 args=$(getopt Vhcd:p:j:D:tGyC $*)
Stefan Reinauer074d9132009-09-26 16:43:17 +0000494 set -- $args
495fi
496
497if [ $? != 0 ]; then
498 myhelp
499 exit 1
500fi
501
502while true ; do
503 case "$1" in
504 -V|--version) shift; myversion; exit 0;;
505 -h|--help) shift; myhelp; exit 0;;
Patrick Georgi44af57a2013-12-19 22:06:22 +0100506 -c|--clean) shift; clean=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000507 -t|--savetemps) shift; SAVETEMPS=1;;
508 -d|--directory) shift; TARGETDIR="$1"; shift;;
509 -p|--platform) shift; TARGETARCH="$1"; shift;;
510 -D|--destdir) shift; DESTDIR="$1"; shift;;
Patrick Georgi73166c72010-04-14 20:42:42 +0000511 -j|--jobs) shift; JOBS="-j $1"; shift;;
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700512 -P|--package) shift; PACKAGE="$1"; shift;;
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100513 -S|--scripting) shift; SKIPPYTHON=0;;
Patrick Georgic1a75b12011-11-04 21:37:14 +0100514 -y|--ccache) shift; USECCACHE=1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200515 --) shift; break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000516 -*) printf "Invalid option\n\n"; myhelp; exit 1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200517 *) break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000518 esac
519done
520
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700521case "$TARGETARCH" in
Stefan Reinauer24f9cb92015-03-13 22:50:22 +0100522 x86_64-elf) ;;
523 x86_64*) TARGETARCH=x86_64-elf;;
David Hubbard5b0420a2013-05-28 16:33:15 -0600524 i386-elf) ;;
525 i386-mingw32) ;;
Patrick Georgi9b7efa52015-03-08 09:20:36 +0100526 mipsel-elf) ;;
Patrick Georgif0bbc952015-03-07 10:57:25 +0100527 riscv-elf) ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700528 i386*) TARGETARCH=i386-elf;;
Patrick Georgic8883262013-09-19 10:57:58 +0200529 arm*) TARGETARCH=armv7-a-eabi;;
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700530 aarch64*) TARGETARCH=aarch64-elf;;
531 *) printf "${red}WARNING: Unsupported architecture $TARGETARCH.${NC}\n\n"; ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700532esac
533
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700534# Figure out which packages to build
Stefan Reinauer699ac272015-06-05 12:43:28 -0700535
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700536case "$PACKAGE" in
537 GCC|gcc)
538 echo "Target architecture is now $TARGETARCH"
539 NAME="${TARGETARCH} cross GCC"
540 PACKAGES="GMP MPFR MPC LIBELF BINUTILS GCC IASL"
541 ;;
542 GDB|gdb)
543 NAME="${TARGETARCH} cross GDB"
544 PACKAGES="GDB"
545 if [ $SKIPPYTHON -eq 0 ]; then
546 PACKAGES="EXPAT PYTHON $PACKAGES"
547 fi
548 ;;
549 CLANG|clang)
550 NAME=clang
551 PACKAGES="LLVM CFE CRT CTE"
552 ;;
553 IASL|iasl)
554 NAME="IASL ACPI compiler"
555 PACKAGES=IASL
556 ;;
557 *)
558 printf "${red}ERROR: Unsupported package $PACKAGE. (Supported packages are GCC, GDB, CLANG, IASL)${NC}\n\n";
559 exit 1
560 ;;
561esac
Peter Stugeceacd772011-06-09 04:54:16 +0200562
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700563# This initial cleanup is useful when updating the toolchain script.
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000564
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700565if [ "$clean" = "1" ]; then
566 cleanup
567fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000568
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700569# Set up host compiler and flags needed for various OSes
Stefan Reinauer074d9132009-09-26 16:43:17 +0000570
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700571CC=cc
Stefan Reinauer429424f2015-06-09 13:45:46 -0700572if [[ "$PACKAGES" == *GCC* ]]; then
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700573if [ $UNAME = "Darwin" ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000574 #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
575
576 # generally the OS X compiler can create x64 binaries.
577 # Per default it generated i386 binaries in 10.5 and x64
578 # binaries in 10.6 (even if the kernel is 32bit)
579 # For some weird reason, 10.5 autodetects an ABI=64 though
580 # so we're setting the ABI explicitly here.
Stefan Reinauerd7649122015-06-09 11:44:25 -0700581 if [ $(sysctl -n hw.optional.x86_64 2>/dev/null) -eq 1 ] 2>/dev/null; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000582 OPTIONS="ABI=64"
583 else
584 OPTIONS="ABI=32"
585 fi
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700586
Stefan Reinauer4266b922012-12-05 16:18:32 -0800587 # In Xcode 4.5.2 the default compiler is clang.
588 # However, this compiler fails to compile gcc 4.7.x. As a
589 # workaround it's possible to compile gcc with llvm-gcc.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700590 if $CC -v 2>&1 | grep -q LLVM; then
Stefan Reinauer4266b922012-12-05 16:18:32 -0800591 CC=llvm-gcc
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700592 fi
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000593fi
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700594fi # GCC
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000595
Patrick Georgic1a75b12011-11-04 21:37:14 +0100596if [ "$USECCACHE" = 1 ]; then
597 CC="ccache $CC"
598fi
599
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700600# Prepare target directory for building GCC
601# (dependencies must be in the PATH)
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100602mkdir -p $DESTDIR$TARGETDIR/bin
603export PATH=$DESTDIR$TARGETDIR/bin:$PATH
604
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700605# Download, unpack, patch and build all packages
606
607printf "Downloading tar balls ... \n"
608mkdir -p tarballs
609for P in $PACKAGES; do
610 download $P
611done
612printf "Downloaded tar balls ... ${green}ok${NC}\n"
613
614printf "Unpacking and patching ... \n"
615for P in $PACKAGES; do
616 unpack_and_patch $P || exit 1
617done
618printf "Unpacked and patched ... ${green}ok${NC}\n"
619
620printf "Building packages ... \n"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700621for package in $PACKAGES; do
622 build $package
623done
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700624printf "Packages built ... ${green}ok${NC}\n"
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700625
Stefan Reinauer699ac272015-06-05 12:43:28 -0700626# Adding git information of current tree to target directory
627# for reproducibility
Stefan Reinauerd7649122015-06-09 11:44:25 -0700628PROGNAME=$(basename "$0")
Patrick Georgi5602f2c2015-03-28 15:48:47 +0100629rm -f "$DESTDIR$TARGETDIR/$PROGNAME".commit.*
Stefan Reinauerd7649122015-06-09 11:44:25 -0700630cp "$PROGNAME" $DESTDIR$TARGETDIR/"$PROGNAME.commit.$(git describe)"
Zheng Bao30b895f2013-02-06 18:04:40 +0800631
Stefan Reinauer074d9132009-09-26 16:43:17 +0000632if [ $SAVETEMPS -eq 0 ]; then
Stefan Reinauer699ac272015-06-05 12:43:28 -0700633 cleanup
Stefan Reinauer074d9132009-09-26 16:43:17 +0000634else
635 printf "Leaving temporary files around... ${green}ok${NC}\n"
636fi
637
Stefan Reinauer699ac272015-06-05 12:43:28 -0700638printf "\n${green}You can now run your $NAME toolchain from $TARGETDIR.${NC}\n"